//sketch_3D_Graph_2

String[] lines;
String[][] pieces_S;
float[][] pieces;

int index = 0;
int Nx_S,Ny_S,Nx,Ny;

float Vmin=1000;//入力最小値
float Vmax=-1000;//入力最小値


void setup()
{
  size(400, 400, P3D);
  colorMode(HSB, 1.2,1.0, 1.0); 
  noStroke();
  lines = loadStrings("OUT_M.XLS");
  Ny_S=lines.length;
  println(Ny_S);
  
  pieces_S=new String[Ny_S][];
  int i,j;
  for(j=0;j<Ny_S;j++)
  {
    pieces_S[j] = split(lines[j], '\t');
    Nx_S=pieces_S[j].length;
    for(i=0;i<Nx_S;i++)
    {
       //print(pieces_S[j][i]);print("  ");
    }
    //println();
  }
  
  ModeA();
  

}

void keyPressed()
{
  //if (key == 'a'){ModeA();}
  switch(key)
  {
    case 'a':
      ModeA();
      break;
    case 'b':
      ModeB();
      break;
    case 'c':
      ModeC();
      break;
    default:
      break;
  }
}

void ModeA()
{
  int i,j;
  Vmin=1000;Vmax=-1000;
  Ny=42;Nx=42;
  pieces=new float[Ny+1][Nx+1];
  for(j=1;j<Ny;j++)
  {
    for(i=1;i<Nx;i++)
    {
      pieces[j][i]=float(pieces_S[j+5-1][i-1]);
      if(pieces[j][i]<Vmin){Vmin=pieces[j][i];}//最小値設定
      if(pieces[j][i]>Vmax){Vmax=pieces[j][i];}//最大値設定
      //print(pieces[j][i]);print("\t");
    }
    //println();
    
  }
  println("ModeA");
  println(Vmin);
  println(Vmax);
  println("key=a set ModeA");
  println("key=b set ModeB");
  println("key=c set ModeC");
}


void ModeB()
{
  int i,j;
  Vmin=1000;Vmax=-1000;
  Ny=42;Nx=42;
  pieces=new float[Ny+1][Nx+1];
  for(j=1;j<Ny;j++)
  {
    for(i=1;i<Nx;i++)
    {
      pieces[j][i]=float(pieces_S[j+48-1][i-1]);
      if(pieces[j][i]<Vmin){Vmin=pieces[j][i];}//最小値設定
      if(pieces[j][i]>Vmax){Vmax=pieces[j][i];}//最大値設定
      //print(pieces[j][i]);print("\t");
    }
    //println();
    
  }
  println("ModeB");
  println(Vmin);
  println(Vmax);
  println("key=a set ModeA");
  println("key=b set ModeB");
  println("key=c set ModeC");
}

void ModeC()
{
  int i,j;
  Vmin=1000;Vmax=-1000;
  Ny=42;Nx=42;
  pieces=new float[Ny+1][Nx+1];
  for(j=1;j<Ny;j++)
  {
    for(i=1;i<Nx;i++)
    {
      pieces[j][i]=float(pieces_S[j+91-1][i-1]);
      if(pieces[j][i]<Vmin){Vmin=pieces[j][i];}//最小値設定
      if(pieces[j][i]>Vmax){Vmax=pieces[j][i];}//最大値設定
      //print(pieces[j][i]);print("\t");
    }
    //println();
    
  }
  println("ModeC");
  println(Vmin);
  println(Vmax);
  println("key=a set ModeA");
  println("key=b set ModeB");
  println("key=c set ModeC");
}

void draw()
{
  background(0,0,1.0);
  lights();
  ortho();
  translate(width / 2, height / 2);
  rotateY(map(mouseX, 0, width, -PI/1, PI/1));
  rotateX(map(mouseY, 0, height, PI/1, -PI/1));
  //scale(2,2,2);
  int i,j;
  for(i=1;i<Nx-2;i++)
  {
    for(j=2;j<Ny-2;j++)
    {
      element(i,j);
    }
  }
}

void element(int i,int j)
{
  float[] Xc=new float[5];
  float[] Yc=new float[5];
  float[] Zc=new float[5];
  float[] C=new float[5];
  
  float Px=8;//表示Xピッチ
  float Py=-100/Vmax;//表示Yピッチ（符号反転）
  float Pz=8;//表示Xピッチ
  
  Xc[1]=Px*(i-Nx/2);Xc[2]=Px*(i+1-Nx/2);Xc[3]=Px*(i+1-Nx/2);Xc[4]=Px*(i-Nx/2);Xc[0]=(Xc[1]+Xc[2]+Xc[3]+Xc[4])/4;
  Yc[1]=Py*pieces[j][i];Yc[2]=Py*pieces[j][i+1];Yc[3]=Py*pieces[j+1][i+1];Yc[4]=Py*pieces[j+1][i];Yc[0]=(Yc[1]+Yc[2]+Yc[3]+Yc[4])/4;
  Zc[1]=Pz*(j-Ny/2);Zc[2]=Pz*(j-Ny/2);Zc[3]=Pz*(j+1-Ny/2);Zc[4]=Pz*(j+1-Ny/2);Zc[0]=(Zc[1]+Zc[2]+Zc[3]+Zc[4])/4;
  
  int li;
  for(li=0;li<4;li++)
  {
    if(li==3)
    {
      C[li]=(Yc[0]+Yc[li+1]+Yc[1])/3;
    }
    else
    {
      C[li]=(Yc[0]+Yc[li+1]+Yc[li+2])/3;
    }
  }
  for(li=0;li<4;li++)
  {
    fill(map(C[li], Vmax*(Py), Vmin*(Py), 0, 1), 1.0, 1.0);
    //fill(0.8, 1.0, 1.0);
    beginShape(TRIANGLES);
    vertex(Xc[0],Yc[0],Zc[0]);
    vertex(Xc[li+1],Yc[li+1],Zc[li+1]);
    if(li==3)
    {
      vertex(Xc[1],Yc[1],Zc[1]);
    }
    else
    {
      vertex(Xc[li+2],Yc[li+2],Zc[li+2]);
    }
    endShape(CLOSE);
  }
}

